# Project governance

This document lays out the guidelines under which the pgcollection project will be governed. The goal is to make sure that the roles and responsibilities are well defined and clarify on how decisions are made.

## Roles

In the context of pgcollection, we consider the following roles:

* __Users__ - everyone using pgcollection, typically willing to provide feedback on pgcollection by proposing features and/or filing issues.
* __Contributors__ - everyone contributing code, documentation, examples, testing infra, and participating in feature proposals as well as design discussions. Code contributions will require a Developer Certificate of Origin (DCO).
*	__Maintainers__ - are responsible for engaging with and assisting contributors to iterate on the contributions until it reaches acceptable quality. Maintainers can decide whether the contributions can be accepted into the project or rejected. Maintainers are responsible for defining the guidelines and processes under which the project operates.

## Communication

All features and bug fixes will be tracked as issues in GitHub. All decisions will be documented in GitHub issues.

In the future, we may consider using a public mailing list or dedicated social media channels.

## Roadmap Planning

From time to time, Maintainers may share roadmap and release versions as milestones in GitHub. 

## Release Management

Maintainers will propose a release management proposal via a GitHub issue and resolve it there.

## Other relevant governance resources

* The pgcollection [Contributing Guidelines](CONTRIBUTING.md)
* Our [Code of Conduct](CODE_OF_CONDUCT.md)

